#include <fstream>
#include <iostream>

using namespace std;

int main(int argc, char **argv) {

	if (argc == 6) {
		char *buffer;
		int c = 0;
		ifstream in;
		ofstream out;
		int width = atoi(argv[2]);
		int height = atoi(argv[3]);
		int flip = atoi(argv[5]);
		int length = width * height;

		in.open(argv[1], ios::binary);
		out.open(argv[4]);
		buffer = new char[length];

		in.read(buffer, length);
		in.close();

		out << "<html>" << endl;
		out << "<body text=\"#00FF66\" bgcolor=\"#000000\">" << endl;
		out << "<font face=courier size=0><pre>" << endl;
		for (int i = 0; i < height; i++) {
			for (int j = 0; j < width; j++) {
				c = buffer[i * width + j];
				if (c < 0) {
					c = 256 + c;
				}
				if (flip) {
					c = 255 - c;
				}
				if (c > 252) {
					out << ' ';
				}
				else if (c > 245) {
					out << '.';
				}
				else if (c > 238) {
					out << '`';
				}
				else if (c > 231) {
					out << ':';
				}
				else if (c > 224) {
					out << '\'';
				}
				else if (c > 217) {
					out << '~';
				}
				else if (c > 210) {
					out << '=';
				}
				else if (c > 203) {
					out << '^';
				}
				else if (c > 196) {
					out << ',';
				}
				else if (c > 189) {
					out << ';';
				}
				else if (c > 182) {
					out << '"';
				}
				else if (c > 175) {
					out << '!';
				}
				else if (c > 168) {
					out << '*';
				}
				else if (c > 161) {
					out << '+';
				}
				else if (c > 154) {
					out << '/';
				}
				else if (c > 147) {
					out << '\\';
				}
				else if (c > 140) {
					out << '|';
				}
				else if (c > 133) {
					out << '$';
				}
				else if (c > 126) {
					out << 'l';
				}
				else if (c > 119) {
					out << '&';
				}
				else if (c > 112) {
					out << 'L';
				}
				else if (c > 105) {
					out << 'F';
				}
				else if (c > 98) {
					out << 'P';
				}
				else if (c > 91) {
					out << '%';
				}
				else if (c > 84) {
					out << '6';
				}
				else if (c > 77) {
					out << '9';
				}
				else if (c > 70) {
					out << '8';
				}
				else if (c > 63) {
					out << 'X';
				}
				else if (c > 56) {
					out << 'R';
				}
				else if (c > 49) {
					out << 'B';
				}
				else if (c > 42) {
					out << 'K';
				}
				else if (c > 35) {
					out << '@';
				}
				else if (c > 28) {
					out << 'E';
				}
				else if (c > 21) {
					out << '#';
				}
				else if (c > 14) {
					out << 'W';
				}
				else if (c > 7) {
					out << 'N';
				}
				else {
					out << 'M';
				}
			}
			out << endl;
		}
		out << "</pre></font>" << endl;
		out << "</body>" << endl;
		out << "</html>";
	}
	else {
		cout << "SYNTAX ERROR: INCORRECT NUMBER OF INPUT PARAMETERS" << endl;
		cout << endl;
		cout << "Syntax:" << endl;
		cout << "ASCIIArt <input> <width> <height> <output> <flip>" << endl;
		cout << endl;
		cout << "Description:" << endl;
		cout << "\tThis is a utility for converting grayscale images" << endl;
		cout << "\tin RAW format into ASCII art.  In order to switch" << endl;
		cout << "\tan image over into grayscale mode, you must have a" << endl;
		cout << "\tutility, such as Photoshop, to do so.  Then the" << endl;
		cout << "\tconverted image must be saved in RAW format" << endl;
		cout << "\twithout any heading information.  Again, you may need" << endl;
		cout << "\tto use a utility such as Photoshop to save the image" << endl;
		cout << "\tin RAW format." << endl;
		cout << endl;
		cout << "Parameters:" << endl;
		cout << "\tinput - the grayscale image in RAW format that you wish" << endl;
		cout << "\tto convert into ASCII art." << endl;
		cout << "\twidth - the width of the image" << endl;
		cout << "\theight - the height of the image" << endl;
		cout << "\toutput - the name of the file that the ASCII art should" << endl;
		cout << "\tshould be saved to" << endl;
		cout << "\tflip - if flip is equal to zero, then light shaded" << endl;
		cout << "\tpixels will be represented with less complex text," << endl;
		cout << "\tsuch as '.' or ' ' and darker shaded pixels will" << endl;
		cout << "\trepresented with more complex text, such as 'M' or 'N';" << endl;
		cout << "\totherwise light shaded pixels will be represented with" << endl;
		cout << "\twith more complex text and darker shaded pixels will" << endl;
		cout << "\tbe represented with less complex text" << endl;
		cout << endl;
		cout << endl;
	}

	return 0;
}